Attribute VB_Name = "EndDbgThread"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' John Robbins
' Microsoft Systems Journal - August, 1997
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FILE         :     EndDbgThread.bas
' DESCRIPTION  :
'  The thread that tells the UI that the debug thread has ended.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

' The type that is passed to the wait thread.
Public Type SPECIALWAIT_TYPE
   ' The thread to wait on.
   hThread As Long
   ' The form to call the DebugThreadEnded method on.  As long as your
   '  form has the DebugThreadEnded method, the type is the only thing
   '  that should be changed in this file.
   frmDTE As frmVBDebug
End Type

' The function that starts the debug thread.
Public Function StartWaitThread(stWaitType As SPECIALWAIT_TYPE) As Long

   Dim hThread As Long
   Dim lThreadID As Long

   ' Create the thread.
   hThread = CreateThread(0, _
                          0, _
                          AddressOf WaitForEndOfDebugThread, _
                          stWaitType, _
                          0, _
                          lThreadID)
   StartWaitThread = hThread

End Function


Public Function WaitForEndOfDebugThread _
                                (stWaitType As SPECIALWAIT_TYPE) As Long

   On Error GoTo WaitForEndOfDebugThread_Error

   Dim bRet As Long

   ' Wait for the debug thread to become signaled, which means it is
   '  done.
   bRet = WaitForSingleObject(stWaitType.hThread, INFINITE)

   ' Instead of calling directly into the form, I would have prefered to
   '  to a PostMessage here, but when this program is run on a
   '  multi-processor machine, the message never makes it through the
   '  runtime.  Therefore, we have to call into the form.
   stWaitType.frmDTE.DebugThreadEnded

   WaitForEndOfDebugThread = 1

   Exit Function

WaitForEndOfDebugThread_Error:
   MsgBox ("Got an error in DebugThread: " + Err.Description)
   WaitForEndOfDebugThread = 0

End Function





